pipeline {
  agent any
  
  tools {nodejs "node"}
  
  environment {
    //Use Pipeline Utility Steps plugin to read information from pom.xml into env variables
    REVISION = "1.0.${env.BUILD_ID}"
    IMAGE = readMavenPom().getArtifactId()
    VERSION = readMavenPom().getVersion()
  }
  
  stages {

    
    stage('Maven Build - Artefato') { 
      agent any
      steps {
        sh 'mvn clean package -Dmaven.test.skip=true'
        stash(name: 'app', includes: 'target/*.jar')
      }
    } 

    stage('Docker Build - Imagem') {
      agent any
      steps {
        unstash 'app'
        sh 'docker build -t chicocx/gestaoclinica:${REVISION} .'
        sh 'docker build -t chicocx/gestaoclinica:latest .'
      }
    }
    stage('Docker Push - DockerHub') {
      agent any
      steps {
        withCredentials(bindings: [usernamePassword(credentialsId: 'dockerhub', passwordVariable: 'dockerHubPassword', usernameVariable: 'dockerHubUser')]) {
          sh "docker login -u ${env.dockerHubUser} -p ${env.dockerHubPassword}"
          sh 'docker push chicocx/gestaoclinica:${REVISION}'
          sh 'docker push chicocx/gestaoclinica:latest'
        }

      }
    }
  }
  
}
